import { createRouter, createWebHistory } from 'vue-router'

import HomeView from '../views/HomeView.vue'

const router = createRouter({
  history: createWebHistory(import.meta.env.BASE_URL),
  routes: [
    {
      path: '/',
      name: 'home',
      component: HomeView,
      meta: { transition: '' },
    },
    {
      path: '/advanced',
      name: 'advanced',
      component: () => import('../views/GameView.vue'),
      meta: { transition: 'route' },
    },
    {
      path: '/normal',
      name: 'normal',
      component: () => import('../views/GameView.vue'),
      meta: { transition: 'route' },
    },
    {
      path: '/practice',
      name: 'practice',
      component: () => import('../views/GameView.vue'),
      meta: { transition: 'route' },
    },
  ],
})

router.afterEach((to, from) => {
  // No transition when direct access
  if (!from.name) {
    to.meta.transition = ''
  }
  // Back animation when going back to home
  else if (to.path === '/') {
    to.meta.transition = 'route_back'
  }
  // Normal forward animation
  else {
    to.meta.transition = 'route'
  }
})

export default router
